OpenJPH: ojph::local::precinct Struct Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::precinct Struct Reference

`#include <ojph_precinct.h>`

## Public Member Functions
| precinct ()
ui32 | prepare_precinct (int tag_tree_size, ui32 *lev_idx, mem_elastic_allocator *elastic)
void | write (outfile_base *file)
void | parse (int tag_tree_size, ui32 *lev_idx, mem_elastic_allocator *elastic, ui32 &data_left, infile_base *file, bool skipped)

## Public Attributes
ui8 * | scratch
point | img_point
rect | cb_idxs [4]
subband * | bands
coded_lists * | coded
bool | may_use_sop
bool | uses_eph

## Detailed Description

Definition at line 58 of file ojph_precinct.h.

## Constructor & Destructor Documentation

## ◆ precinct()

ojph::local::precinct::precinct | ( |  | ) |
| inline

Definition at line 60 of file ojph_precinct.h.

References bands, coded, may_use_sop, scratch, and uses_eph.

## Member Function Documentation

## ◆ parse()

void ojph::local::precinct::parse | ( | int | tag_tree_size,
|  | ui32 * | lev_idx,
|  | mem_elastic_allocator * | elastic,
|  | ui32 & | data_left,
|  | infile_base * | file,
|  | bool | skipped )

Definition at line 328 of file ojph_precinct.cpp.

References bands, ojph::local::bb_init(), ojph::local::bb_read_bit(), ojph::local::bb_read_bits(), ojph::local::bb_read_chunk(), ojph::local::bb_skip_sop(), ojph::local::bb_terminate(), ojph::local::bit_read_buf::bytes_left, cb_idxs, ojph::count_leading_zeros(), ojph::local::tag_tree::get(), ojph::local::tag_tree::init(), ojph::local::coded_cb_header::Kmax, ojph::local::log2ceil(), may_use_sop, ojph::local::coded_cb_header::missing_msbs, ojph::local::coded_cb_header::next_coded, ojph::local::coded_cb_header::num_passes, ojph_max, ojph_min, ojph::infile_base::OJPH_SEEK_CUR, ojph::local::coded_cb_header::pass_length, scratch, ojph::infile_base::tell(), and uses_eph.

Referenced by ojph::local::resolution::parse_all_precincts(), and ojph::local::resolution::parse_one_precinct().

## ◆ prepare_precinct()

ui32 ojph::local::precinct::prepare_precinct | ( | int | tag_tree_size,
|  | ui32 * | lev_idx,
|  | mem_elastic_allocator * | elastic )

Definition at line 94 of file ojph_precinct.cpp.

References ojph::coded_lists::avail_size, bands, ojph::local::bb_init(), ojph::local::bb_put_bit(), ojph::local::bb_put_bits(), ojph::local::bb_put_zeros(), ojph::local::bb_terminate(), ojph::coded_lists::buf_size, cb_idxs, coded, ojph::count_leading_zeros(), ojph::local::tag_tree::get(), ojph::local::tag_tree::init(), ojph::local::log2ceil(), ojph::local::coded_cb_header::missing_msbs, ojph::local::coded_cb_header::next_coded, ojph::local::coded_cb_header::num_passes, ojph_max, ojph_min, ojph::local::coded_cb_header::pass_length, and scratch.

## ◆ write()

void ojph::local::precinct::write | ( | outfile_base * | file | ) |

Definition at line 281 of file ojph_precinct.cpp.

References ojph::coded_lists::avail_size, bands, ojph::coded_lists::buf, ojph::coded_lists::buf_size, cb_idxs, coded, ojph::local::coded_cb_header::next_coded, ojph::coded_lists::next_list, and ojph::outfile_base::write().

## Member Data Documentation

## ◆ bands

subband* ojph::local::precinct::bands

Definition at line 74 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc(), parse(), precinct(), prepare_precinct(), and write().

## ◆ cb_idxs

rect ojph::local::precinct::cb_idxs[4]

Definition at line 73 of file ojph_precinct.h.

Referenced by ojph::local::subband::get_cb_indices(), parse(), prepare_precinct(), and write().

## ◆ coded

coded_lists* ojph::local::precinct::coded

Definition at line 75 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc(), precinct(), prepare_precinct(), and write().

## ◆ img_point

point ojph::local::precinct::img_point

Definition at line 72 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc().

## ◆ may_use_sop

bool ojph::local::precinct::may_use_sop

Definition at line 76 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc(), parse(), and precinct().

## ◆ scratch

ui8* ojph::local::precinct::scratch

Definition at line 71 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc(), parse(), precinct(), and prepare_precinct().

## ◆ uses_eph

bool ojph::local::precinct::uses_eph

Definition at line 76 of file ojph_precinct.h.

Referenced by ojph::local::resolution::finalize_alloc(), parse(), and precinct().

The documentation for this struct was generated from the following files:

- /startdir/src/OpenJPH/src/core/codestream/ojph_precinct.h
- /startdir/src/OpenJPH/src/core/codestream/ojph_precinct.cpp